package nullSim;


/*  <NullSim - the art of nothing
    Copyright (C) <2008>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import infoCCD.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class NullSim extends JFrame implements WindowListener, ActionListener {
	
	public NullSim(String [] args) {
		addWindowListener(this);
		new Info(true,true,true);
		
		JPanel nullImagePanel = new JPanel(new FlowLayout());
		nullImagePanel.setBackground(Color.black);
		ResourceGetter rG = new ResourceGetter(Info.runType);
		Icon nullSimImage = new ImageIcon(rG.getResource(Info.appIcon));
		nullImagePanel.add(new JLabel(nullSimImage));
		this.add(nullImagePanel);
		
		makeMenuBar();
		
		this.setSize(200,200);
		this.setResizable(false);
		this.setVisible(true);
	}

	public void makeMenuBar () {
		MenuBar theMenuBar = new MenuBar();
		this.setMenuBar(theMenuBar);

		// Add menu for program control
		Menu m = new Menu ("Program");
		m.addActionListener(this);
		
		m.add(("Don't Run"));
		m.add("Stay Paused");
		m.add("Don't Even Restart");
		
		m.addSeparator();
		
		m.add("Don't Open File");
		m.add("Don't Save File");
		
		theMenuBar.add(m);
	
		theMenuBar.add(Info.infoMenu);		// this one if you're using a MenuBar
		// theMenuBar.add(Info.jInfoMenu);	// this one if you're using a JMenuBar
		
	}
	
	public void actionPerformed( ActionEvent event ) {
		String arg = event.getActionCommand( );
		System.out.println(arg);
		
		if ( arg.equals( "Don't Run") ) {
			System.out.println("Done not running!");
		}
		
		if ( arg.equals( "Stay Paused") ) {
			System.out.println("OK... hum-dee-dum-dee-dum...");
		}
		
		if ( arg.equals( "Don't Even Restart") ) {
			System.out.println("I said 'Don't Even' !!!!");
		}
		
		if ( arg.equals( "Don't Open File") ) {
			System.out.println("Don't tell me what not to do... grrrr.");
		}
		
		if ( arg.equals( "Don't Save File") ) {
			System.out.println("I saved the file... so there!");
		}
		Info.setConsoleVisible(true);
	}
	
	/**
	 *  Handles a window closing event notifying the application
	 *  that the user has chosen to close the application without
	 *  selecting the "Exit" menu item.
	 *
	 *  @param   event   a WindowEvent indicating the window is closing
	 */
	public void windowClosing( WindowEvent event )
	{
		System.exit(0);
	}
	public void windowClosed( WindowEvent event )
	{
	}
	public void windowOpened( WindowEvent event )
	{
	}
	public void windowIconified( WindowEvent event )
	{
	}
	public void windowDeiconified( WindowEvent event )
	{
	}
	public void windowActivated( WindowEvent event )
	{
	}
	public void windowDeactivated( WindowEvent event )
	{
	}
	
	public static void loadNullSimParams (String nullParamsStr) {
		Info.setConsoleVisible(true);
		System.out.println("Faux loading (just echo) a big string of parameters...");
		int misunderstandings = 0;
		int bolIndex = 0;	// beginning-of-line index
		int eolIndex = 0;	// end-of-line index
		String curLine;
		String endLine = "\n";//System.getProperty("line.separator");
		int finalIndex = nullParamsStr.lastIndexOf(endLine);	// we stop at last occurrence of end-of-line
		while (bolIndex < finalIndex) {
			eolIndex = nullParamsStr.indexOf(endLine,bolIndex);
	    	curLine = nullParamsStr.substring(bolIndex,eolIndex);
	    	if (!curLine.startsWith("//") & !curLine.startsWith(Info.appParamID) & (curLine.length() >= 1)) {
				boolean matchFound = true; // replace with call to code to get parameter on this line
				System.out.println("Would've read parameters from : " + curLine);
				if (!matchFound) { misunderstandings++; }
			}
			// next line
			bolIndex = eolIndex+1;
		}
		System.out.println ("Done... there were " + String.valueOf(misunderstandings) + " misunderstandings.");
	}


}